# Struct hyper::client::Builder [−] [src]

    pub struct Builder { /* fields omitted */ }

A builder to configure a new `Client`.

# Example

    use std::time::Duration;
    use hyper::Client;

    let client = Client::builder()
        .pool_idle_timeout(Duration::from_secs(30))
        .http2_only(true)
        .build_http();

## Implementations

### `impl Builder` [src]

#### `pub fn pool_idle_timeout<D>(&mut self, val: D) -> &mut Self where
D: Into<Option<Duration>>,` [src]

Set an optional timeout for idle sockets being kept-alive.

Pass `None` to disable timeout.

Default is 90 seconds.

#### `pub fn pool_max_idle_per_host(&mut self, max_idle: usize) -> &mut Self` [src]

Sets the maximum idle connection per host allowed in the pool.

Default is `usize::MAX` (no limit).

#### `pub fn http1_read_buf_exact_size(&mut self, sz: usize) -> &mut Self` [src]

Sets the exact size of the read buffer to always use.

Note that setting this option unsets the `http1_max_buf_size` option.

Default is an adaptive read buffer.

#### `pub fn http1_max_buf_size(&mut self, max: usize) -> &mut Self` [src]

Set the maximum buffer size for the connection.

Default is ~400kb.

Note that setting this option unsets the `http1_read_exact_buf_size` option.

# Panics

The minimum value allowed is 8192. This method panics if the passed `max` is less than the minimum.

#### `pub fn http1_title_case_headers(&mut self, val: bool) -> &mut Self` [src]

Set whether HTTP/1 connections will write header names as title case at the socket level.

Note that this setting does not affect HTTP/2.

Default is false.

#### `pub fn http2_only(&mut self, val: bool) -> &mut Self` [src]

Set whether the connection must use HTTP/2.

The destination must either allow HTTP2 Prior Knowledge, or the `Connect` should be configured to do use ALPN to upgrade to `h2` as part of the connection process. This will not make the `Client` utilize ALPN by itself.

Note that setting this to true prevents HTTP/1 from being allowed.

Default is false.

#### `pub fn http2_initial_stream_window_size(
&mut self,
sz: impl Into<Option<u32>>
) -> &mut Self` [src]

Sets the `SETTINGS_INITIAL_WINDOW_SIZE` option for HTTP2 stream-level flow control.

Passing `None` will do nothing.

If not set, hyper will use a default.

#### `pub fn http2_initial_connection_window_size(
&mut self,
sz: impl Into<Option<u32>>
) -> &mut Self` [src]

Sets the max connection-level flow control for HTTP2

Passing `None` will do nothing.

If not set, hyper will use a default.

#### `pub fn http2_adaptive_window(&mut self, enabled: bool) -> &mut Self` [src]

Sets whether to use an adaptive flow control.

Enabling this will override the limits set in `http2_initial_stream_window_size` and `http2_initial_connection_window_size`.

#### `pub fn http2_max_frame_size(&mut self, sz: impl Into<Option<u32>>) -> &mut Self` [src]

Sets the maximum frame size to use for HTTP2.

Passing `None` will do nothing.

If not set, hyper will use a default.

#### `pub fn http2_keep_alive_interval(
&mut self,
interval: impl Into<Option<Duration>>
) -> &mut Self` [src]

Sets an interval for HTTP2 Ping frames should be sent to keep a connection alive.

Pass `None` to disable HTTP2 keep-alive.

Default is currently disabled.

# Cargo Feature

Requires the `runtime` cargo feature to be enabled.

#### `pub fn http2_keep_alive_timeout(&mut self, timeout: Duration) -> &mut Self` [src]

Sets a timeout for receiving an acknowledgement of the keep-alive ping.

If the ping is not acknowledged within the timeout, the connection will be closed. Does nothing if `http2_keep_alive_interval` is disabled.

Default is 20 seconds.

# Cargo Feature

Requires the `runtime` cargo feature to be enabled.

#### `pub fn http2_keep_alive_while_idle(&mut self, enabled: bool) -> &mut Self` [src]

Sets whether HTTP2 keep-alive should apply while the connection is idle.

If disabled, keep-alive pings are only sent while there are open request/responses streams. If enabled, pings are also sent when no streams are active. Does nothing if `http2_keep_alive_interval` is disabled.

Default is `false`.

# Cargo Feature

Requires the `runtime` cargo feature to be enabled.

#### `pub fn retry_canceled_requests(&mut self, val: bool) -> &mut Self` [src]

Set whether to retry requests that get disrupted before ever starting to write.

This means a request that is queued, and gets given an idle, reused connection, and then encounters an error immediately as the idle connection was found to be unusable.

When this is set to `false`, the related `ResponseFuture` would instead resolve to an `Error::Cancel`.

Default is `true`.

#### `pub fn set_host(&mut self, val: bool) -> &mut Self` [src]

Set whether to automatically add the `Host` header to requests.

If true, and a request does not include a `Host` header, one will be added automatically, derived from the authority of the `Uri`.

Default is `true`.

#### `pub fn executor<E>(&mut self, exec: E) -> &mut Self where
E: Executor<Pin<Box<dyn Future<Output = ()> + Send>>> + Send + Sync + 'static,` [src]

Provide an executor to execute background `Connection` tasks.

#### `pub fn build_http<B>(&self) -> Client<HttpConnector, B> where
B: HttpBody + Send,
B::Data: Send,` [src]

Builder a client with this configuration and the default `HttpConnector`.

#### `pub fn build<C, B>(&self, connector: C) -> Client<C, B> where
C: Connect + Clone,
B: HttpBody + Send,
B::Data: Send,` [src]

Combine the configuration of this builder with a connector to create a `Client`.

## Trait Implementations

### `impl Clone for Builder` [src]

#### `fn clone(&self) -> Builder` [src]

Returns a copy of the value. Read more

#### `pub fn clone_from(&mut self, source: &Self)`1.0.0 [src]

Performs copy-assignment from `source`. Read more

### `impl Debug for Builder` [src]

#### `fn fmt(&self, f: &mut Formatter<'_>) -> Result` [src]

Formats the value using the given formatter. Read more

### `impl Default for Builder` [src]

#### `fn default() -> Self` [src]

Returns the “default value” for a type. Read more

## Auto Trait Implementations

### `impl !RefUnwindSafe for Builder`

### `impl Send for Builder`

### `impl Sync for Builder`

### `impl Unpin for Builder`

### `impl !UnwindSafe for Builder`

## Blanket Implementations

### `impl<T> Any for T where
T: 'static + ?Sized,` [src]

#### `pub fn type_id(&self) -> TypeId` [src]

Gets the `TypeId` of `self`. Read more

### `impl<T> Borrow<T> for T where
T: ?Sized,` [src]

#### `pub fn borrow(&self) -> &T` [src]

Immutably borrows from an owned value. Read more

### `impl<T> BorrowMut<T> for T where
T: ?Sized,` [src]

#### `pub fn borrow_mut(&mut self) -> &mut T` [src]

Mutably borrows from an owned value. Read more

### `impl<T> From<T> for T` [src]

#### `pub fn from(t: T) -> T` [src]

Performs the conversion.

### `impl<T> Instrument for T` [src]

#### `pub fn instrument(self, span: Span) -> Instrumented<Self>` [src]

Instruments this type with the provided `Span`, returning an `Instrumented` wrapper. Read more

#### `pub fn in_current_span(self) -> Instrumented<Self>` [src]

Instruments this type with the current `Span`, returning an `Instrumented` wrapper. Read more

### `impl<T, U> Into<U> for T where
U: From<T>,` [src]

#### `pub fn into(self) -> U` [src]

Performs the conversion.

### `impl<T> ToOwned for T where
T: Clone,` [src]

#### `type Owned = T`

The resulting type after obtaining ownership.

#### `pub fn to_owned(&self) -> T` [src]

Creates owned data from borrowed data, usually by cloning. Read more

#### `pub fn clone_into(&self, target: &mut T)` [src]

🔬 This is a nightly-only experimental API. (`toowned_clone_into`)

recently added

Uses borrowed data to replace owned data, usually by cloning. Read more

### `impl<T, U> TryFrom<U> for T where
U: Into<T>,` [src]

#### `type Error = Infallible`

The type returned in the event of a conversion error.

#### `pub fn try_from(value: U) -> Result<T, <T as TryFrom<U>>::Error>` [src]

Performs the conversion.

### `impl<T, U> TryInto<U> for T where
U: TryFrom<T>,` [src]

#### `type Error = <U as TryFrom<T>>::Error`

The type returned in the event of a conversion error.

#### `pub fn try_into(self) -> Result<U, <U as TryFrom<T>>::Error>` [src]

Performs the conversion.